/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "xplog.h"

/* HomeDirectory */
extern char *user;
extern char xpuser[1024];

extern int a;
extern char APuffer[256];

/* Preference Datas */
extern struct xplog xplogs;    /* Preference Datas */

/* Deal Protection */
struct xplDealProt   xplDP;

/* Protect */
void ProtectEd(int mo)
{
   char                 buffer[20];

   /* Loop Integer */
   int                  aa,bb,cc;

   int                  xDP,yDP;

   xplDP.form = fl_bgn_form(FL_UP_BOX,466,489);

   fl_set_border_width(2);

   /* Browser 334 */
   xplDP.viewfield = fl_add_frame(FL_DOWN_FRAME,10,10,446,440,"");

   /* Weekday Bar */
   xDP=53+5; /* 12; */
   yDP=12;
   if (mo==0)
   {
      xplDP.QPLbarA[0] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday1); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[0],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[1] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday2); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[1],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[2] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday3); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[2],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[3] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday4); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[3],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[4] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday5); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[4],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[5] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday6); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[5],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[6] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday7);
      fl_set_object_color(xplDP.QPLbarA[6],FL_DARKCYAN,FL_MCOL);
   }
   else if (mo==1)
   {
      xplDP.QPLbarA[0] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday1); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[0],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[1] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday2); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[1],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[2] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday3); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[2],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[3] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday4); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[3],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[4] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday5); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[4],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[5] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday6); xDP=xDP+50;
      fl_set_object_color(xplDP.QPLbarA[5],FL_DARKCYAN,FL_MCOL);
      xplDP.QPLbarA[6] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday7);
      fl_set_object_color(xplDP.QPLbarA[6],FL_DARKCYAN,FL_MCOL);
   }

   xDP=53+5; /* 12; */
   yDP=428; /* 12; */
   if (mo==0)
   {
      xplDP.QPLbarB[0] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday1); xDP=xDP+50;
      xplDP.QPLbarB[1] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday2); xDP=xDP+50;
      xplDP.QPLbarB[2] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday3); xDP=xDP+50;
      xplDP.QPLbarB[3] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday4); xDP=xDP+50;
      xplDP.QPLbarB[4] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday5); xDP=xDP+50;
      xplDP.QPLbarB[5] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday6); xDP=xDP+50;
      xplDP.QPLbarB[6] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP,50,20,_xpl_prday7);
   }
   else if (mo==1)
   {
      xplDP.QPLbarB[0] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday1); xDP=xDP+50;
      xplDP.QPLbarB[1] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday2); xDP=xDP+50;
      xplDP.QPLbarB[2] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday3); xDP=xDP+50;
      xplDP.QPLbarB[3] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday4); xDP=xDP+50;
      xplDP.QPLbarB[4] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday5); xDP=xDP+50;
      xplDP.QPLbarB[5] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday6); xDP=xDP+50;
      xplDP.QPLbarB[6] = fl_add_box(FL_DOWN_FRAME,xDP,yDP,50,20,_xpl_prday7);
   }

   /* Info Calculation */
   xDP=12;
   yDP=32+1+5;
   for (aa=0 ; aa<=23 ; aa++)
   {
      if (aa==0) strcpy(buffer,"00:00");
      if (aa==1) strcpy(buffer,"01:00");
      if (aa==2) strcpy(buffer,"02:00");
      if (aa==3) strcpy(buffer,"03:00");
      if (aa==4) strcpy(buffer,"04:00");
      if (aa==5) strcpy(buffer,"05:00");
      if (aa==6) strcpy(buffer,"06:00");
      if (aa==7) strcpy(buffer,"07:00");
      if (aa==8) strcpy(buffer,"08:00");
      if (aa==9) strcpy(buffer,"09:00");
      if (aa==10) strcpy(buffer,"10:00");
      if (aa==11) strcpy(buffer,"11:00");
      if (aa==12) strcpy(buffer,"12:00");
      if (aa==13) strcpy(buffer,"13:00");
      if (aa==14) strcpy(buffer,"14:00");
      if (aa==15) strcpy(buffer,"15:00");
      if (aa==16) strcpy(buffer,"16:00");
      if (aa==17) strcpy(buffer,"17:00");
      if (aa==18) strcpy(buffer,"18:00");
      if (aa==19) strcpy(buffer,"19:00");
      if (aa==20) strcpy(buffer,"20:00");
      if (aa==21) strcpy(buffer,"21:00");
      if (aa==22) strcpy(buffer,"22:00");
      if (aa==23) strcpy(buffer,"23:00");

      bb=40+1+5;
      cc=   1+5;

      if (mo==0)
      {
         /* activate */
         xplDP.QPLTimeA[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP,yDP+(aa*16),40,16,buffer);
         fl_set_object_color(xplDP.QPLTimeA[aa],FL_DARKCYAN,FL_MCOL);

         /* Su */
         xplDP.QPLsu[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+bb,yDP+(aa*16),50,16,buffer);
         /* Mo */
         xplDP.QPLmo[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+50+bb,yDP+(aa*16),50,16,buffer);
         /* Tu */
         xplDP.QPLtu[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+100+bb,yDP+(aa*16),50,16,buffer);
         /* We */
         xplDP.QPLwe[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+150+bb,yDP+(aa*16),50,16,buffer);
         /* Th */
         xplDP.QPLth[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+200+bb,yDP+(aa*16),50,16,buffer);
         /* Fr */
         xplDP.QPLfr[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+250+bb,yDP+(aa*16),50,16,buffer);
         /* Sa */
         xplDP.QPLsa[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+300+bb,yDP+(aa*16),50,16,buffer);

         /* deactivate */
         xplDP.QPLTimeB[aa] = fl_add_button(FL_NORMAL_BUTTON,xDP+350+bb+cc,yDP+(aa*16),40,16,buffer);
      }
      else if (mo==1)
      {
         /* activate */
         xplDP.QPLTimeA[aa] = fl_add_box(FL_DOWN_FRAME,xDP,yDP+(aa*16),40,16,buffer);
         fl_set_object_color(xplDP.QPLTimeA[aa],FL_DARKCYAN,FL_MCOL);

         /* Su */
         xplDP.QPLsu[aa] = fl_add_box(FL_DOWN_FRAME,xDP+bb,yDP+(aa*16),50,16,buffer);
         /* Mo */
         xplDP.QPLmo[aa] = fl_add_box(FL_DOWN_FRAME,xDP+50+bb,yDP+(aa*16),50,16,buffer);
         /* Tu */
         xplDP.QPLtu[aa] = fl_add_box(FL_DOWN_FRAME,xDP+100+bb,yDP+(aa*16),50,16,buffer);
         /* We */
         xplDP.QPLwe[aa] = fl_add_box(FL_DOWN_FRAME,xDP+150+bb,yDP+(aa*16),50,16,buffer);
         /* Th */
         xplDP.QPLth[aa] = fl_add_box(FL_DOWN_FRAME,xDP+200+bb,yDP+(aa*16),50,16,buffer);
         /* Fr */
         xplDP.QPLfr[aa] = fl_add_box(FL_DOWN_FRAME,xDP+250+bb,yDP+(aa*16),50,16,buffer);
         /* Sa */
         xplDP.QPLsa[aa] = fl_add_box(FL_DOWN_FRAME,xDP+300+bb,yDP+(aa*16),50,16,buffer);

         /* deactivate */
         xplDP.QPLTimeB[aa] = fl_add_box(FL_DOWN_FRAME,xDP+350+bb+cc,yDP+(aa*16),40,16,buffer);
      }
   }

   xplDP.QPLframe = fl_add_frame(FL_DOWN_FRAME,10,455,446,24,"");
   xplDP.QPLexit = fl_add_button(FL_NORMAL_BUTTON,203,457,60,20,_xpl_exit);

   fl_end_form();

   fl_show_form(xplDP.form,FL_PLACE_CENTER,FL_TRANSIENT,_xpl_wintitle);

   /* Display Deal Protection */
   ViewProtection();

   /* mark aktual position */
   if (mo==1)
   {
      if (xplDP.aa==0) fl_set_object_lcol(xplDP.QPLsu[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==1) fl_set_object_lcol(xplDP.QPLmo[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==2) fl_set_object_lcol(xplDP.QPLtu[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==3) fl_set_object_lcol(xplDP.QPLwe[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==4) fl_set_object_lcol(xplDP.QPLth[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==5) fl_set_object_lcol(xplDP.QPLfr[xplDP.bb],FL_YELLOW);
      if (xplDP.aa==6) fl_set_object_lcol(xplDP.QPLsa[xplDP.bb],FL_YELLOW);
   }

   xplDP.ready=0;
   while (xplDP.ready == 0)
   {
      xplDP.obj = fl_do_forms();

      /* Exit */
      if (xplDP.obj == xplDP.QPLexit)
      {
         xplDP.ready=1;
      }

      /* Day Selection */
      for (aa=0 ; aa<7 ; aa++)
      {
         if (xplDP.QPLbarA[aa] == xplDP.obj)
         {
            for (bb=0 ; bb<24 ; bb++)
            {
               xplogs.xpDP[aa][bb]='\1';
            }
            ViewProtection();
         }
         if (xplDP.QPLbarB[aa] == xplDP.obj)
         {
            for (bb=0 ; bb<24 ; bb++)
            {
               xplogs.xpDP[aa][bb]='\0';
            }
            ViewProtection();
         }
      }

      /* Time Selection */
      for (bb=0 ; bb<24 ; bb++)
      {
         if (xplDP.QPLTimeA[bb] == xplDP.obj)
         {
            for (aa=0 ; aa<7 ; aa++)
            {
               xplogs.xpDP[aa][bb]='\1';
            }
            ViewProtection();
         }
         if (xplDP.QPLTimeB[bb] == xplDP.obj)
         {
            for (aa=0 ; aa<7 ; aa++)
            {
               xplogs.xpDP[aa][bb]='\0';
            }
            ViewProtection();
         }
      }


      /* Week-Entrys */
      cc=0;
      for (aa=0 ; aa<7 ; aa++)
      {
         for (bb=0 ; bb<24 ; bb++)
         {
            if ( (aa==0) && (xplDP.QPLsu[bb] == xplDP.obj) ) cc=1;
            if ( (aa==1) && (xplDP.QPLmo[bb] == xplDP.obj) ) cc=1;
            if ( (aa==2) && (xplDP.QPLtu[bb] == xplDP.obj) ) cc=1;
            if ( (aa==3) && (xplDP.QPLwe[bb] == xplDP.obj) ) cc=1;
            if ( (aa==4) && (xplDP.QPLth[bb] == xplDP.obj) ) cc=1;
            if ( (aa==5) && (xplDP.QPLfr[bb] == xplDP.obj) ) cc=1;
            if ( (aa==6) && (xplDP.QPLsa[bb] == xplDP.obj) ) cc=1;

            if (cc == 1)
            {
               if (xplogs.xpDP[aa][bb]=='\0')
               {
                  xplogs.xpDP[aa][bb]='\1';
               }
               else
               {
                  xplogs.xpDP[aa][bb]='\0';
               }
               ViewProtection();
               cc=0;
            }
         }
      }



   }

   fl_hide_form(xplDP.form);

   return;
}

/* Display Deal Protection */
void ViewProtection(void)
{
   int            a,b;

   for (a=0 ; a<7 ; a++)
   {
      for (b=0 ; b<24 ; b++)
      {
         if (xplogs.xpDP[a][b]=='\0')
         {
            if (a==0) fl_set_object_color(xplDP.QPLsu[b],FL_COL1,FL_MCOL);
            if (a==1) fl_set_object_color(xplDP.QPLmo[b],FL_COL1,FL_MCOL);
            if (a==2) fl_set_object_color(xplDP.QPLtu[b],FL_COL1,FL_MCOL);
            if (a==3) fl_set_object_color(xplDP.QPLwe[b],FL_COL1,FL_MCOL);
            if (a==4) fl_set_object_color(xplDP.QPLth[b],FL_COL1,FL_MCOL);
            if (a==5) fl_set_object_color(xplDP.QPLfr[b],FL_COL1,FL_MCOL);
            if (a==6) fl_set_object_color(xplDP.QPLsa[b],FL_COL1,FL_MCOL);
         }
         else
         {
            if (a==0) fl_set_object_color(xplDP.QPLsu[b],FL_DARKCYAN,FL_MCOL);
            if (a==1) fl_set_object_color(xplDP.QPLmo[b],FL_DARKCYAN,FL_MCOL);
            if (a==2) fl_set_object_color(xplDP.QPLtu[b],FL_DARKCYAN,FL_MCOL);
            if (a==3) fl_set_object_color(xplDP.QPLwe[b],FL_DARKCYAN,FL_MCOL);
            if (a==4) fl_set_object_color(xplDP.QPLth[b],FL_DARKCYAN,FL_MCOL);
            if (a==5) fl_set_object_color(xplDP.QPLfr[b],FL_DARKCYAN,FL_MCOL);
            if (a==6) fl_set_object_color(xplDP.QPLsa[b],FL_DARKCYAN,FL_MCOL);
         }
      }
   }

   return;
}

/* Check Deal Protection */
int CheckProtection(long atime)
{
   int            aa,bb,cc;

   struct tm      *aatm;
   struct tm      atm;
   int            weekday;
   int            timecode;

   aatm = localtime(&atime);
   atm.tm_mday=aatm->tm_mday;
   atm.tm_mon=aatm->tm_mon+1;
   atm.tm_year=aatm->tm_year+1900;
   atm.tm_hour=aatm->tm_hour;
   atm.tm_min=aatm->tm_min;
   atm.tm_sec=aatm->tm_sec;

   /* Weekday */
   weekday=getDay(atm.tm_mday,atm.tm_mon,atm.tm_year);

   /* Timecode */
   timecode=(atm.tm_hour*3600)+(atm.tm_min*60)+atm.tm_sec;

   cc=0;
   for (bb=23 ; bb>-1 ; bb--)
   {
      aa=bb*3600;

      if ( (timecode>=aa) && (timecode<aa+3600) )
      {
         cc=bb;
      }
   }

   if (xplogs.xpDP[weekday][cc]!='\0')
   {
      xplDP.aa=weekday;
      xplDP.bb=cc;
      ProtectEd(1);
      return(1);
   }

   return(0);
}
